﻿
@{
    ViewBag.Title = "List";
    Layout = "~/Areas/Admin/Views/Shared/_Layout.cshtml";
}


<div class="wrapper-grid">
    <div class="k-rtl">
        @(Html.Kendo().Grid<Category>()
           .Name("grid")
           .Events(e => e.Edit("Edit"))
           .Columns(columns =>
           {
               columns.Bound(c => c.Name);
               columns.Bound(c => c.EnglishName);           
               columns.Command(command => { command.Edit().Text(" "); command.Destroy().Text(" "); }).Width(150);
           })
          .ToolBar(toolbar =>
          {
              toolbar.Create().Text("افزودن گروه");
          })
          .Groupable()
          .ColumnMenu()

          .Editable(editable =>
          {
              editable.Mode(GridEditMode.PopUp).Window(q => q.Width(700));
              editable.DisplayDeleteConfirmation("آیا از حذف این ردیف اطمینان دارید ؟ ");
          }
          )
          .Pageable(pageable => pageable
               .Refresh(true)
               .PageSizes(true)
               .ButtonCount(10).Messages(m => m.ItemsPerPage("نمایش در هر صفحه"))
               .PageSizes(new int[] { 10, 20, 30 }))
          .Navigatable()
          .Selectable(selectable =>
          {
              selectable.Mode(GridSelectionMode.Single);
              selectable.Type(GridSelectionType.Row);
          })
          .Sortable(sortable =>
          {
              sortable.SortMode(GridSortMode.SingleColumn);
          })
          .Filterable()
          .Scrollable(s => s.Height("auto").Enabled(false))
          .DataSource(dataSource => dataSource
              .Ajax()
              .Events(e => e.Error("Error"))
              .Sort(sort => sort.Add("CategoryID").Descending())
              .Model(model => model.Id(p => p.CategoryID))
              .Read(read => read.Action("Category_Read", "Category"))
              .Create(create => create.Action("Category_Create", "Category"))
              .Update(update => update.Action("Category_Update", "Category"))
              .Destroy(destroy => destroy.Action("Category_Destroy", "Category"))
          )
        )
    </div>
</div>

<script>
    function Edit(e) {

        //$(e.container["0"].firstChild.children[0]).hide();
        //$(e.container["0"].firstChild.children[1]).hide();
        //$(e.container["0"].firstChild.children[8]).hide();
        //$(e.container["0"].firstChild.children[9]).hide();
        //$(e.container["0"].firstChild.children[10]).hide();
        //$(e.container["0"].firstChild.children[11]).hide();
     

        var kendoWindow = e.container.data("kendoWindow");
        if (e.model.isNew()) {
            kendoWindow.setOptions({
                title: "افزودن گروه"
            });
        } else {
            kendoWindow.setOptions({
                title: "ویرایش گروه"
            });
        }

    }
    function Error(e) {
        if (e.errors) {
            var message = "خطای رخ داده:\n";
            $.each(e.errors, function (key, value) {
                if ('errors' in value) {
                    $.each(value.errors, function () {
                        message += this + "\n";
                    });
                }
            });
            alert(message);
        }
    }
</script>



<!-- #region  tree View categories -->
@*@section styles{
        <style>

           h3{font-size:16px;margin-right:38px;}
           ul{list-style-type:none;}
           li input ,  button{margin-bottom:5px !important;}
           .CatTreeView{padding-right:100px;}
           .row{text-align:center;}
           .wrapper-grid{margin:50px 150px 20px 10px;}
           button{font-size:14px !important;}
           #filterDataSource{width:198px;}
           #enableAllNodes{width:124px;}
           #sortDataSource{width:197px;}
           #cat{font-weight:bold;}
        </style>
        }

    <div class="container CatTreeView">
        <div class="box wide">
            <div class="row">

                <div class="col col-md-3">
                    <div class="box-col">
                        <h3>افزودن / حذف</h3>
                        <ul class="options">
                            <li>
                                <input id="appendNodeText" class="k-textbox" value="گره" />
                            </li>
                            <li>
                                <input id="appendEnglishNameText" value="" class="k-textbox" placeholder="نام انگلیسی" />
                            </li>
                            <li>
                                <button class="k-button light-green" id="appendNodeToSelected">افزودن گره</button>
                                <button class="k-button" id="removeNode">حذف گره</button>
                            </li>

                        </ul>
                    </div>
                </div>
                <div class="col col-md-3">
                    <div class="box-col">
                        <h3>فعال / غیرفعال</h3>
                        <ul class="options">
                            <li>
                                <button class="k-button" id="disableNode">غیرفعال کردن گره </button>
                            </li>
                            <li>
                                <button class="k-button" id="enableAllNodes">فعال کردن گره</button>
                            </li>
                        </ul>
                    </div>
                </div>
                <div class="col col-md-3">
                    <div class="box-col">
                        <h3>نمایش  / مخفی  </h3>
                        <ul class="options">
                            <li>
                                <button class="k-button" id="expandAllNodes">نمایش تمام گره ها</button>
                            </li>
                            <li>
                                <button class="k-button" id="collapseAllNodes">بستن تمام گره ها</button>
                            </li>
                        </ul>
                    </div>
                </div>
                <div class="col col-md-3">
                    <div class="box-col">
                        <h3>تعامل با پایگاه داده</h3>
                        <ul class="options">
                            <li>
                                <button class="k-button" id="sortDataSource">مرتب سازی</button>
                            </li>
                            <li>
                                <input id="filterText" class="k-textbox" placeholder="نوشته" />
                                <button class="k-button" id="filterDataSource">فیلتر بر اساس نوشته</button>
                            </li>
                        </ul>
                    </div>
                </div>
            </div>
        </div>
        <hr/>


        <div class="wrapper-grid">
            <p id="cat">گروه ها : </p>
            <div class="k-rtl">
                @(Html.Kendo().TreeView()
             .Name("treeview")
             .DataTextField("Name")
             .Template("#=item.id# - #=item.Name#")
             .DataSource(dataSource => dataSource
             .Read(read => read
                    .Action("TreeView", "Category")
                )
            )
                )
            </div>
        </div>
    </div>
    <script>

        $(document).ready(function () {


            var treeview = $("#treeview").data("kendoTreeView"),
                handleTextBox = function (callback) {
                    return function (e) {
                        if (e.type != "keypress" || kendo.keys.ENTER == e.keyCode) {
                            callback(e);
                        }
                    };
                };

            $("#disableNode").click(function () {
                var selectedNode = treeview.select();
                treeview.enable(selectedNode, false);
            });

            $("#enableAllNodes").click(function () {
                var selectedNode = treeview.select();
                treeview.enable(".k-item");
            });

            $("#removeNode").click(function () {
                var tree = $('#treeview').data('kendoTreeView'),
                selected = tree.select(),
                item = tree.dataItem(selected);
                if (typeof item === "undefined") {
                    alert("لطفا گره مورد نظر را انتخاب نمائید .")
                } else {
                    $.ajax({
                        url: "/Admin/Category/DeleteNode",
                        type: "POST",
                        data: {
                            id:item.id
                        },
                        success: function (res) {
                            treeview.remove(selected);
                            alert(res)
                        }
                    });
                }
            });

            $("#expandAllNodes").click(function () {
                treeview.expand(".k-item");
            });

            $("#collapseAllNodes").click(function () {
                treeview.collapse(".k-item");
            });

            var append = handleTextBox(function (e) {
                var selectedNode = treeview.select();
                if (selectedNode.length == 0) {
                    selectedNode = null;
                }
                treeview.append({
                    text: $("#appendNodeText").val()
                }, selectedNode);
                var tree = $('#treeview').data('kendoTreeView'),
                 selected = tree.select(),
                 item = tree.dataItem(selected);
                if (typeof item === "undefined") {
                    var parentid = null
                }
                else {
                    parentid = item.id
                }

                if ($("#appendEnglishNameText").val() == null || $("#appendEnglishNameText").val() == "") {
                    alert("وارد کردن نام انگلیسی الزامی است .")
                    return false;
                }

                $.ajax({
                    url: "/Admin/Category/AddNode",
                    type: "POST",
                    data: {
                        Name: $("#appendNodeText").val(),
                        ParentID: parentid,
                        EnglishName:  $("#appendEnglishNameText").val(),
                    },
                    success: function (res) {
                        if (res.errorMessage != null) {
                            alert(res.errorMessage)
                        } else {
                            location.reload();
                            alert("گره با موفقیت ثبت شد .")
                        }

                    }
                });

            });

            $("#appendNodeToSelected").click(append);
            $("#appendNodeText").keypress(append);

            var ascending = false;
            $("#sortDataSource")
                .text(ascending ? "Sort ascending" : "Sort descending")
                .click(function () {
                    treeview.dataSource.sort({
                        field: "text",
                        dir: ascending ? "asc" : "desc"
                    });

                    ascending = !ascending;

                    $(this).text(ascending ? "Sort ascending" : "Sort descending")
                });

            var filter = handleTextBox(function (e) {
                var filterText = $("#filterText").val();

                if (filterText !== "") {
                    treeview.dataSource.filter({
                        field: "text",
                        operator: "contains",
                        value: filterText
                    });
                } else {
                    treeview.dataSource.filter({});
                }
            });

            $("#filterDataSource").click(filter);
            $("#filterText").keypress(filter);
        });
    </script>*@

<!-- #endregion -->
